      function EngCom(job, k, mt, mp)
c
c***********************************************************************
c     function EngCom returns the COM energy for given incident
c     lab momentum k, where mp is the mass of projectile and mt
c     is the mass of target
c 
c     if job = 0, relativistic formular is used
c     else  non-relativistic formular.
c
c     Ref. Eq. 1.35 and 1.37, page 13 of QM II by Landau
c***********************************************************************
c
      implicit none
      integer job
      double precision two, EngCom, k, mp, mt, mp2
c
      parameter (two = 2.0d0)
c***********************************************************************
c
      mp2 = mp*mp
      if (job .eq. 0) then
         EngCom = sqrt(mt*mt + mp2 + two*mt*sqrt(mp2+k*k))
      else
         write(8, *) 'not yet implimented'
         stop
      endif
c
      return
      end
