c
      subroutine SetUp
c
c***********************************************************************
c     SetUp sets up the masses for every channels, and the
c     SU(2) coupling constants between the channels.
c***********************************************************************

      double precision Cplv, Cplct, Cplcs
      double precision zero, one, two, three, four, five, sqrt2, sqrt3
      double precision proton, neutron, delta, pip, pi0, pim
      double precision mpion, Mass

c     mass.h Version 1.1 masses of pion, nucleon and delta 
      common /mass/ mpion, Mass(2)
      common /couple/ Cplv(3,3),Cplct(2,2,2),Cplcs(2,2,2)

      parameter (zero=0.0d0,one=1.0d0,two=2.0d0,three=3.0d0,four=4.0d0)
      parameter (five=5.0d0,sqrt2=1.41421356237d0,sqrt3=1.73205080757d0)
c     taken from 'Rev of Part Prop', Phys Let B, Vol 239. 12 April 1990
      parameter (proton=938.272d0, neutron=939.565d0, delta=1232.d0)
      parameter (pip=139.5675d0,pi0=134.9739d0,pim=139.5675d0)
c
c***********************************************************************
c
c use isospin avarage masses 
c      mpion = (pip + pi0 + pim)/three
c      use mpion (from input in kpinit.f) to test chiral symmetry
c      
      Mass(1) = (proton + neutron)/two
      Mass(2) = delta
c
c     now initialize the SU(2) coupling constants
c
c     Cplv(2,3) is for s and u channel vervex
c     1 denotes for N; 2 for Delta; 3 for Roper
      Cplv(1,1) = five
      Cplv(1,2) = two * sqrt2
      Cplv(1,3) = five/sqrt3
      Cplv(2,1) = four * sqrt2
      Cplv(2,2) = five
      Cplv(2,3) = four*sqrt2/sqrt3
      Cplv(3,1) = Cplv(1,3)
      Cplv(3,2) = Cplv(2,3)
      Cplv(3,3) = zero
c
c     Cplct(2,2,2) 
c 
      Cplct(1,1,1) = -1.d0
      Cplct(1,2,1) = zero
      Cplct(2,1,1) = zero
      Cplct(2,2,1) = -2.5d0
      Cplct(1,1,2) =  0.5d0 
      Cplct(1,2,2) = zero
      Cplct(2,1,2) = zero 
      Cplct(2,2,2) = -1.d0
c
c     Cplcs(2,2,2)
c
      Cplcs(1,1,1) = -five/three
      Cplcs(1,2,1) = -two*sqrt2/three
      Cplcs(2,1,1) = Cplcs(1,2,1)
      Cplcs(2,2,1) = 5.d0*sqrt(10.d0)/6.d0
      Cplcs(1,1,2) = 5.d0/6.d0
      Cplcs(1,2,2) = -2.d0*sqrt(5.d0)/3.d0
      Cplcs(2,1,2) = Cplcs(1,2,2)
      Cplcs(2,2,2) = sqrt(10.d0)/3.d0
      return
      end
